kdefx Library: KPixmapEffect Class Reference (kdefx Library)

| # kdefx Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Namespaces | Source Files

# KPixmapEffect Class Reference

This class includes various pixmap-based graphical effects. More...

`#include <kpixmapeffect.h>`

List of all members.

## Public Types
enum | GradientType { VerticalGradient, HorizontalGradient, DiagonalGradient, CrossDiagonalGradient, PyramidGradient, RectangleGradient, PipeCrossGradient, EllipticGradient }
enum | RGBComponent { Red, Green, Blue }
enum | Lighting { NorthLite, NWLite, WestLite, SWLite, SouthLite, SELite, EastLite, NELite }
## Static Public Member Functions
static KPixmap & | gradient (KPixmap &pixmap, const QColor &ca, const QColor &cb, GradientType type, int ncols=3)
static KPixmap & | unbalancedGradient (KPixmap &pixmap, const QColor &ca, const QColor &cb, GradientType type, int xfactor=100, int yfactor=100, int ncols=3)
static KPixmap | createTiled (const KPixmap &pixmap, QSize size)
static KPixmap & | intensity (KPixmap &pixmap, float ratio)
static KPixmap & | channelIntensity (KPixmap &pixmap, float ratio, RGBComponent channel)
static KPixmap & | blend (KPixmap &pixmap, float initial_intensity, const QColor &bgnd, GradientType eff, bool anti_dir=false, int ncols=3)
static KPixmap & | hash (KPixmap &pixmap, Lighting lite=NorthLite, unsigned int spacing=0, int ncols=3)
static KPixmap | pattern (const KPixmap &pixmap, QSize size, const QColor &ca, const QColor &cb, int ncols=8)
static KPixmap & | fade (KPixmap &pixmap, double val, const QColor &color)
static KPixmap & | toGray (KPixmap &pixmap, bool fast=false)
static KPixmap & | desaturate (KPixmap &pixmap, float desat=0.3)
static KPixmap & | contrast (KPixmap &pixmap, int c)
static KPixmap & | dither (KPixmap &pixmap, const QColor *palette, int size)
static KPixmap | selectedPixmap (const KPixmap &pixmap, const QColor &col)

## Detailed Description

This class includes various pixmap-based graphical effects.

Everything is static, so there is no need to create an instance of this class. You can just call the static methods. They are encapsulated here merely to provide a common namespace.

Definition at line 27 of file kpixmapeffect.h.

## Member Function Documentation

KPixmap & KPixmapEffect::gradient | ( | KPixmap & | pixmap,
|  | const QColor & | ca,
|  | const QColor & | cb,
|  | GradientType | type,
|  | int | ncols = `3`
| ) | `[static]`

  | Creates a gradient from color a to color b of the specified type. Parameters:
  | pixmap | The pixmap to process.
  | ca | Color a.
  | cb | Color b.
  | type | The type of gradient.
  | ncols | The number of colors to use when not running on a truecolor display. The gradient will be dithered to this number of colors. Pass 0 to prevent dithering.
Returns: Returns the generated pixmap, for convenience. Definition at line 24 of file kpixmapeffect.cpp. References QPainter::drawLine(), KImageEffect::gradient(), and QPainter::setPen().

KPixmap & KPixmapEffect::unbalancedGradient | ( | KPixmap & | pixmap,
|  | const QColor & | ca,
|  | const QColor & | cb,
|  | GradientType | type,
|  | int | xfactor = `100`,
|  | int | yfactor = `100`,
|  | int | ncols = `3`
| ) | `[static]`

  | Creates an unbalanced gradient. An unbalanced gradient is a gradient where the transition from color a to color b is not linear, but in this case, exponential. Parameters:
  | pixmap | The pixmap that should be written.
  | ca | Color a.
  | cb | Color b.
  | type | The type of gradient.
  | xfactor | The x decay length. Use a value between -200 and 200.
  | yfactor | The y decay length.
  | ncols | The number of colors. See gradient.
Returns: The generated pixmap, for convencience. Definition at line 88 of file kpixmapeffect.cpp. References KImageEffect::unbalancedGradient().

KPixmap KPixmapEffect::createTiled | ( | const KPixmap & | pixmap,
|  | QSize | size
| ) | `[static]`

  | Creates a pixmap of a given size with the given pixmap. if the given size is bigger than the size of the pixmap, the pixmap is tiled. Parameters:
  | pixmap | This is the source pixmap
  | size | The size the new pixmap should have.
Returns: The generated, tiled pixmap. Definition at line 240 of file kpixmapeffect.cpp. References QPainter::drawTiledPixmap(), QSize::height(), and QSize::width(). Referenced by pattern().

KPixmap & KPixmapEffect::intensity | ( | KPixmap & | pixmap,
|  | float | ratio
| ) | `[static]`

  | Either brightens or dims a pixmap by a specified ratio. Parameters:
  | pixmap | The pixmap to process.
  | ratio | The ratio to use. Use negative value to dim.
Returns: Returns The pixmap(), provided for convenience. Definition at line 109 of file kpixmapeffect.cpp. References QPixmap::convertToImage(), and KImageEffect::intensity().

KPixmap & KPixmapEffect::channelIntensity | ( | KPixmap & | pixmap,
|  | float | ratio,
|  | RGBComponent | channel
| ) | `[static]`

  | Modifies the intensity of a pixmap's RGB channel component. Parameters:
  | pixmap | The pixmap to process.
  | ratio | value. Use negative value to dim.
  | channel | Which channel(s) should be modified
Returns: Returns the pixmap(), provided for convenience. Definition at line 121 of file kpixmapeffect.cpp. References KImageEffect::channelIntensity(), and QPixmap::convertToImage().

KPixmap & KPixmapEffect::blend | ( | KPixmap & | pixmap,
|  | float | initial_intensity,
|  | const QColor & | bgnd,
|  | GradientType | eff,
|  | bool | anti_dir = `false`,
|  | int | ncols = `3`
| ) | `[static]`

  | Blends the provided pixmap into a background of the indicated color. Parameters:
  | pixmap | The pixmap to process.
  | initial_intensity | this parameter takes values from -1 to 1: If positive, it tells how much to fade the image in its less affected spot. If negative, it tells roughly indicates how much of the image remains unaffected
  | bgnd | Indicates the color of the background to blend in.
  | eff | Lets you choose what kind of blending you like.
  | anti_dir | Blend in the opposite direction (makes no much sense with concentric blending effects).
  | ncols | The number of colors to dither the pixmap to. Only used for 8 bpp pixmaps.
Returns: Returns the pixmap(), provided for convenience. Definition at line 140 of file kpixmapeffect.cpp. References KImageEffect::blend(), QImage::convertDepth(), QPixmap::convertToImage(), QImage::depth(), KImageEffect::dither(), and QColor::setRgb().

KPixmap & KPixmapEffect::hash | ( | KPixmap & | pixmap,
|  | Lighting | lite = `NorthLite`,
|  | unsigned int | spacing = `0`,
|  | int | ncols = `3`
| ) | `[static]`

  | Builds a hash on any given pixmap. Parameters:
  | pixmap | The pixmap to process.
  | lite | The hash faces the indicated lighting (cardinal poles)
  | spacing | How many unmodified pixels inbetween hashes.
  | ncols | The number of colors to dither the pixmap to. Only used for 8 bpp pixmaps.
Returns: Returns The pixmap(), provided for convenience. Definition at line 179 of file kpixmapeffect.cpp. References QPixmap::convertToImage(), KImageEffect::dither(), KImageEffect::hash(), and QColor::setRgb().

KPixmap KPixmapEffect::pattern | ( | const KPixmap & | pixmap,
|  | QSize | size,
|  | const QColor & | ca,
|  | const QColor & | cb,
|  | int | ncols = `8`
| ) | `[static]`

  | Creates a pattern from a pixmap. The given pixmap is "flattened" between color a to color b. Doesn't change the original pixmap. Parameters:
  | pixmap | The pixmap to process.
  | size | The size of the returned pixmap. If `size` is larger than the original, the resulting pixmap will be tiled.
  | ca | Color a.
  | cb | Color b.
  | ncols | The number of colors to use. The image will be dithered to this depth. Pass zero to prevent dithering.
Returns: The resulting pixmap. Definition at line 223 of file kpixmapeffect.cpp. References KPixmap::convertFromImage(), QPixmap::convertToImage(), createTiled(), and KImageEffect::flatten().

KPixmap & KPixmapEffect::fade | ( | KPixmap & | pixmap,
|  | double | val,
|  | const QColor & | color
| ) | `[static]`

  | Fades a pixmap to a certain color. Parameters:
  | pixmap | The pixmap to process.
  | val | The strength of the effect. 0 <= val <= 1.
  | color | The color to blend to.
Returns: Returns the pixmap(), provided for convenience. Definition at line 257 of file kpixmapeffect.cpp. References QPixmap::convertToImage(), and KImageEffect::fade().

KPixmap & KPixmapEffect::toGray | ( | KPixmap & | pixmap,
|  | bool | fast = `false`
| ) | `[static]`

  | Converts a pixmap to grayscale. Parameters:
  | pixmap | The pixmap to process.
  | fast | Set to `true` in order to use a faster but non-photographic quality algorithm. Appropriate for things such as toolbar icons.
Returns: Returns the pixmap(), provided for convenience. Definition at line 268 of file kpixmapeffect.cpp. References QPixmap::convertToImage(), and KImageEffect::toGray().

KPixmap & KPixmapEffect::desaturate | ( | KPixmap & | pixmap,
|  | float | desat = `0.3`
| ) | `[static]`

  | Desaturates a pixmap. Parameters:
  | pixmap | The pixmap to process.
  | desat | A value between 0 and 1 setting the degree of desaturation
Returns: Returns The pixmap(), provided for convenience. Definition at line 278 of file kpixmapeffect.cpp. References QPixmap::convertToImage(), and KImageEffect::desaturate().

KPixmap & KPixmapEffect::contrast | ( | KPixmap & | pixmap,
|  | int | c
| ) | `[static]`

  | Modifies the contrast of a pixmap. Parameters:
  | pixmap | The pixmap to process.
  | c | A contrast value between -255 and 255.
Returns: Returns the pixmap(), provided for convenience. Definition at line 287 of file kpixmapeffect.cpp. References KImageEffect::contrast(), and QPixmap::convertToImage().

KPixmap & KPixmapEffect::dither | ( | KPixmap & | pixmap,
|  | const QColor * | palette,
|  | int | size
| ) | `[static]`

  | Dithers a pixmap using Floyd-Steinberg dithering for low-color situations. Parameters:
  | pixmap | The pixmap to process.
  | palette | The color palette to use.
  | size | The size of the palette.
Returns: Returns the pixmap(), provided for convenience. Definition at line 303 of file kpixmapeffect.cpp. References QPixmap::convertToImage(), and KImageEffect::dither().

KPixmap KPixmapEffect::selectedPixmap | ( | const KPixmap & | pixmap,
|  | const QColor & | col
| ) | `[static]`

  | Calculate a 'selected' pixmap, for instance a selected icon on the desktop. Parameters:
  | pixmap | the pixmap to select
  | col | the selected color, usually from QColorGroup::highlight().
Definition at line 318 of file kpixmapeffect.cpp. References KPixmap::convertFromImage(), QPixmap::convertToImage(), and KImageEffect::selectedImage().

The documentation for this class was generated from the following files:

- kpixmapeffect.h
- kpixmapeffect.cpp

This file is part of the documentation for kdefx Library Version 3.4.1.
Documentation copyright © 1996-2004 the KDE developers.
Generated on Sat Jun 11 20:17:10 2005 by doxygen 1.4.1 written by Dimitri van Heesch, © 1997-2003